/[gentoo-x86]/eclass/kde4-meta.eclass
Gentoo

Diff of /eclass/kde4-meta.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.11 Revision 1.51
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.11 2009/03/01 11:44:09 scarabeus Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.51 2011/04/06 14:22:14 scarabeus Exp $
4# 4#
5# @ECLASS: kde4-meta.eclass 5# @ECLASS: kde4-meta.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: Eclass for writing "split" KDE packages. 8# @BLURB: Eclass for writing "split" KDE packages.
10# This eclass provides all necessary functions for writing split KDE ebuilds. 10# This eclass provides all necessary functions for writing split KDE ebuilds.
11# 11#
12# You must define KMNAME to use this eclass, and do so before inheriting it. All other variables are optional. 12# You must define KMNAME to use this eclass, and do so before inheriting it. All other variables are optional.
13# Do not include the same item in more than one of KMMODULE, KMMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY. 13# Do not include the same item in more than one of KMMODULE, KMMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY.
14 14
15inherit kde4-base versionator
16
17EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm
18
19if [[ -z ${KMNAME} ]]; then
20 die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild" 15[[ -z ${KMNAME} ]] && die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild"
21fi
22 16
23case ${KDEBASE} in 17inherit kde4-base toolchain-funcs versionator
24 kde-base) 18
25 HOMEPAGE="http://www.kde.org/" 19case ${EAPI:-0} in
26 LICENSE="GPL-2" 20 3)
21 KDEMETA_EXPF="pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_preinst pkg_postinst pkg_postrm"
27 ;; 22 ;;
28 koffice) 23 *)
29 HOMEPAGE="http://www.koffice.org/" 24 KDEMETA_EXPF="pkg_pretend pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_preinst pkg_postinst pkg_postrm"
30 LICENSE="GPL-2"
31 ;; 25 ;;
32esac 26esac
27EXPORT_FUNCTIONS ${KDEMETA_EXPF}
33 28
34# Add dependencies that all packages in a certain module share. 29# Add dependencies that all packages in a certain module share.
35case ${KMNAME} in 30case ${KMNAME} in
36 kdebase|kdebase-workspace|kdebase-runtime) 31 kdebase|kdebase-apps|kdebase-workspace|kdebase-runtime|kdegraphics)
37 DEPEND="${DEPEND} >=kde-base/qimageblitz-0.0.4" 32 COMMONDEPEND+=" >=media-libs/qimageblitz-0.0.4"
38 RDEPEND="${RDEPEND} >=kde-base/qimageblitz-0.0.4"
39 ;; 33 ;;
40 kdepim) 34 kdepim|kdepim-runtime)
41 DEPEND="${DEPEND} dev-libs/boost app-office/akonadi-server"
42 RDEPEND="${RDEPEND} dev-libs/boost"
43 if [[ ${PN} != kode ]]; then
44 DEPEND="${DEPEND} >=kde-base/kode-${PV}:${SLOT}[kdeprefix=]"
45 RDEPEND="${RDEPEND} >=kde-base/kode-${PV}:${SLOT}[kdeprefix=]"
46 fi
47 case ${PN} in 35 case ${PN} in
48 akregator|kaddressbook|kjots|kmail|kmobiletools|knode|knotes|korganizer|ktimetracker) 36 akregator|kaddressbook|kjots|kmail|knode|knotes|korganizer|ktimetracker)
49 IUSE="+kontact" 37 IUSE+=" +kontact"
50 DEPEND="${DEPEND} kontact? ( >=kde-base/kontactinterfaces-${PV}:${SLOT}[kdeprefix=] )" 38 RDEPEND+=" kontact? ( $(add_kdebase_dep kontact) )"
51 RDEPEND="${RDEPEND} kontact? ( >=kde-base/kontactinterfaces-${PV}:${SLOT}[kdeprefix=] )"
52 ;; 39 ;;
53 esac 40 esac
54 ;; 41 ;;
55 kdegames) 42 kdegames)
56 if [[ ${PN} != libkdegames ]]; then 43 if [[ ${PN} != libkdegames ]]; then
57 DEPEND="${DEPEND} >=kde-base/libkdegames-${PV}:${SLOT}[kdeprefix=]" 44 COMMONDEPEND+=" $(add_kdebase_dep libkdegames)"
58 RDEPEND="${RDEPEND} >=kde-base/libkdegames-${PV}:${SLOT}[kdeprefix=]"
59 fi 45 fi
60 ;; 46 ;;
61 koffice) 47 koffice)
62 [[ ${PN} != koffice-data ]] && IUSE="debug" 48 [[ ${PN} != koffice-data ]] && IUSE+=" debug"
63 case ${PV} in 49 RDEPEND+="
64 9999*) DEPEND="${DEPEND} !app-office/${PN}:2" ;;
65 1.9*|2*) DEPEND="${DEPEND} !app-office/${PN}:live" ;;
66 esac
67 DEPEND="${DEPEND}
68 !app-office/${PN}:0 50 !app-office/${PN}:0
69 !app-office/koffice:0 51 !app-office/koffice:0
70 !app-office/koffice-meta:0" 52 !app-office/koffice-meta:0
71 case ${PN} in 53 "
72 koffice-data) 54 if has openexr ${IUSE//+}; then
73 DEPEND="${DEPEND} media-libs/lcms" 55 COMMONDEPEND+=" media-gfx/imagemagick[openexr?]"
74 RDEPEND="${RDEPEND} media-libs/lcms" 56 else
75 ;; 57 COMMONDEPEND+=" media-gfx/imagemagick"
76 *) 58 fi
77 DEPEND="${DEPEND} 59
60 COMMONDEPEND+="
78 dev-cpp/eigen:2 61 dev-cpp/eigen:2
79 media-gfx/imagemagick[openexr?]
80 media-libs/fontconfig 62 media-libs/fontconfig
81 media-libs/freetype:2 63 media-libs/freetype:2
82 " 64 "
83 RDEPEND="${DEPEND}"
84 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then 65 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then
85 DEPEND="${DEPEND} 66 COMMONDEPEND+=" >=app-office/koffice-libs-${PV}:${SLOT}"
86 >=app-office/koffice-libs-${PV}:${SLOT}[kdeprefix=]"
87 RDEPEND="${RDEPEND}
88 >=app-office/koffice-libs-${PV}:${SLOT}[kdeprefix=]"
89 fi 67 fi
90 ;;
91 esac
92 ;; 68 ;;
93esac 69esac
94 70
71DEPEND+=" ${COMMONDEPEND}"
72RDEPEND+=" ${COMMONDEPEND}"
73unset COMMONDEPEND
74
95debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies" 75debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies"
96debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies" 76debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies"
97 77
98# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc) 78# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc)
99case ${SLOT} in 79case ${BUILD_TYPE} in
100 live) 80 live)
81 if [[ ${KDE_SCM} == svn ]]; then
101 case ${KMNAME} in 82 case ${KMNAME} in
102 extragear*|playground*) 83 extragear*|playground*)
103 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}" 84 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
85 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
104 ;; 86 ;;
105 esac 87 esac
88 fi
106 ;; 89 ;;
107esac 90esac
108 91
109# @ECLASS-VARIABLE: KMNAME 92# @ECLASS-VARIABLE: KMNAME
110# @DESCRIPTION: 93# @DESCRIPTION:
125# If set to "true", $KMMODULE doesn't have to be defined. 108# If set to "true", $KMMODULE doesn't have to be defined.
126# 109#
127# Example usage: If you're installing subdirectories of a package, like plugins, 110# Example usage: If you're installing subdirectories of a package, like plugins,
128# you mark the top subdirectory (containing the package) as $KMEXTRACTONLY, and 111# you mark the top subdirectory (containing the package) as $KMEXTRACTONLY, and
129# set KMNOMODULE="true". 112# set KMNOMODULE="true".
130if [[ -z ${KMMODULE} && ${KMNOMODULE} != true ]]; then 113if [[ -z ${KMMODULE} ]] && [[ ${KMNOMODULE} != true ]]; then
131 KMMODULE=${PN} 114 KMMODULE=${PN}
132fi 115fi
133 116
134# @ECLASS-VARIABLE: KMEXTRA 117# @ECLASS-VARIABLE: KMEXTRA
135# @DESCRIPTION: 118# @DESCRIPTION:
136# All subdirectories listed here will be extracted, compiled & installed. 119# All subdirectories listed here will be extracted, compiled & installed.
137# $KMMODULE is always added to $KMEXTRA. 120# $KMMODULE is always added to $KMEXTRA.
138# If the htmlhandbook USE-flag is set, and if this directory exists, 121# If KDE_HANDBOOK is 'always' or 'optional' and handbook USE-flag is set, and if this
139# then "doc/$KMMODULE" is added to $KMEXTRA. In other cases, this should be 122# directory exists, then "doc/$KMMODULE" is added to $KMEXTRA. If there's additional
140# handled in the ebuild.
141# If the documentation is in a different subdirectory, you should add it to KMEXTRA. 123# documentation in different subdirectories, it should be added to KMEXTRA manually..
142 124
143# @ECLASS-VARIABLE: KMCOMPILEONLY 125# @ECLASS-VARIABLE: KMCOMPILEONLY
144# @DESCRIPTION: 126# @DESCRIPTION:
145# All subdirectories listed here will be extracted & compiled, but not installed. 127# All subdirectories listed here will be extracted & compiled, but not installed.
146 128
153# @ECLASS-VARIABLE: KMTARPARAMS 135# @ECLASS-VARIABLE: KMTARPARAMS
154# @DESCRIPTION: 136# @DESCRIPTION:
155# Specify extra parameters to pass to tar, in kde4-meta_src_extract. 137# Specify extra parameters to pass to tar, in kde4-meta_src_extract.
156# '-xpf -j' are passed to tar by default. 138# '-xpf -j' are passed to tar by default.
157 139
140# @FUNCTION: kde4-meta_pkg_pretend
141# @DESCRIPTION:
142# Currently only checks the gcc version.
143kde4-meta_pkg_pretend() {
144 debug-print-function ${FUNCNAME} "$@"
145
146 slot_is_at_least 4.6 ${SLOT} && ( [[ $(gcc-major-version) -lt 4 ]] || \
147 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 3 ]] ) ) \
148 && die "Sorry, but gcc-4.3 and earlier wont work for KDE SC 4.6 (see bug 354837)."
149}
150
158# @FUNCTION: kde4-meta_pkg_setup 151# @FUNCTION: kde4-meta_pkg_setup
159# @DESCRIPTION: 152# @DESCRIPTION:
160# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in 153# Currently calls its equivalent in kde4-base.eclass(5) and checks the gcc version.
161# split ebuilds. 154# Use this one in split ebuilds.
162kde4-meta_pkg_setup() { 155kde4-meta_pkg_setup() {
163 debug-print-function ${FUNCNAME} "$@" 156 debug-print-function ${FUNCNAME} "$@"
164 157
158 has pkg_pretend ${KDEMETA_EXPF} || kde4-meta_pkg_pretend
159
165 kde4-base_pkg_setup 160 kde4-base_pkg_setup
166} 161}
167 162
168# @FUNCTION: kde4-meta_src_unpack 163# @FUNCTION: kde4-meta_src_unpack
169# @DESCRIPTION: 164# @DESCRIPTION:
170# This function unpacks the source for split ebuilds. See also 165# This function unpacks the source for split ebuilds.
171# kde4-meta-src_extract. 166# Further more is processed in kde4-meta_src_extract
172kde4-meta_src_unpack() { 167kde4-meta_src_unpack() {
173 debug-print-function ${FUNCNAME} "$@" 168 debug-print-function ${FUNCNAME} "$@"
174 169
175 if [[ ${BUILD_TYPE} = live ]]; then 170 if [[ ${BUILD_TYPE} = live ]]; then
171 case "${KDE_SCM}" in
172 svn)
176 migrate_store_dir 173 migrate_store_dir
177 S="${WORKDIR}/${P}" 174 S="${WORKDIR}/${P}"
178 mkdir -p "${S}" 175 mkdir -p "${S}"
179 ESVN_RESTRICT="export" subversion_src_unpack 176 ESVN_RESTRICT="export" subversion_src_unpack
180 subversion_wc_info 177 subversion_wc_info
181 subversion_bootstrap 178 subversion_bootstrap
179 ;;
180 git)
181 git_src_unpack
182 ;;
183 esac
184 fi
182 kde4-meta_src_extract 185 kde4-meta_src_extract
183 else
184 kde4-meta_src_extract
185 fi
186} 186}
187
188# FIXME: the difference between kde4-meta_src_extract and kde4-meta_src_unpack?
189 187
190# @FUNCTION: kde4-meta_src_extract 188# @FUNCTION: kde4-meta_src_extract
191# @DESCRIPTION: 189# @DESCRIPTION:
192# A function to unpack the source for a split KDE ebuild. 190# A function to extract the source for a split KDE ebuild.
193# Also see KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and 191# Also see KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and
194# KMTARPARAMS. 192# KMTARPARAMS.
195kde4-meta_src_extract() { 193kde4-meta_src_extract() {
196 debug-print-function ${FUNCNAME} "$@" 194 debug-print-function ${FUNCNAME} "$@"
197 195
198 if [[ ${BUILD_TYPE} = live ]]; then 196 if [[ ${BUILD_TYPE} = live ]]; then
199 local rsync_options subdir kmnamedir targetdir
200 # Export working copy to ${S} 197 # Export working copy to ${S}
201 einfo "Exporting parts of working copy to ${S}" 198 einfo "Exporting parts of working copy to ${S}"
202 kde4-meta_create_extractlists 199 kde4-meta_create_extractlists
203 200
201 case ${KDE_SCM} in
202 svn)
203 local rsync_options subdir kmnamedir targetdir wc_path escm
204
204 rsync_options="--group --links --owner --perms --quiet --exclude=.svn/" 205 rsync_options="--group --links --owner --perms --quiet --exclude=.svn/ --exclude=.git/"
206 wc_path="${ESVN_WC_PATH}"
207 escm="{ESVN}"
205 208
206 # Copy ${KMNAME} non-recursively (toplevel files) 209 # Copy ${KMNAME} non-recursively (toplevel files)
207 rsync ${rsync_options} "${ESVN_WC_PATH}"/${kmnamedir}* "${S}" \ 210 rsync ${rsync_options} "${wc_path}"/${kmnamedir}* "${S}" \
208 || die "${ESVN}: can't export toplevel files to '${S}'." 211 || die "${escm}: can't export toplevel files to '${S}'."
209 # Copy cmake directory 212 # Copy cmake directory
210 if [[ -d "${ESVN_WC_PATH}/${kmnamedir}cmake" ]]; then 213 if [[ -d "${wc_path}/${kmnamedir}cmake" ]]; then
211 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}cmake" "${S}" \ 214 rsync --recursive ${rsync_options} "${wc_path}/${kmnamedir}cmake" "${S}" \
212 || die "${ESVN}: can't export cmake files to '${S}'." 215 || die "${escm}: can't export cmake files to '${S}'."
213 fi
214 # Copy all subdirectories
215 for subdir in $(__list_needed_subdirectories); do
216 targetdir=""
217 if [[ $subdir = doc/* && ! -e "$ESVN_WC_PATH/$kmnamedir$subdir" ]]; then
218 continue
219 fi 216 fi
217 # Copy all subdirectories
218 for subdir in $(__list_needed_subdirectories); do
219 targetdir=""
220 if [[ $subdir = doc/* && ! -e "$wc_path/$kmnamedir$subdir" ]]; then
221 continue
222 fi
220 223
221 [[ ${subdir%/} = */* ]] && targetdir=${subdir%/} && targetdir=${targetdir%/*} && mkdir -p "${S}/${targetdir}" 224 [[ ${subdir%/} = */* ]] && targetdir=${subdir%/} && targetdir=${targetdir%/*} && mkdir -p "${S}/${targetdir}"
222 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}${subdir%/}" "${S}/${targetdir}" \ 225 rsync --recursive ${rsync_options} "${wc_path}/${kmnamedir}${subdir%/}" "${S}/${targetdir}" \
223 || die "${ESVN}: can't export subdirectory '${subdir}' to '${S}/${targetdir}'." 226 || die "${escm}: can't export subdirectory '${subdir}' to '${S}/${targetdir}'."
224 done 227 done
225 228 ;;
226 if [[ ${KMNAME} = kdebase-runtime && ${PN} != kdebase-data ]]; then 229 esac
227 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
228 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
229 fi
230 else 230 else
231 local abort tarball tarfile f extractlist moduleprefix 231 local abort tarball tarfile f extractlist moduleprefix postfix
232 232
233 KMTARPARAMS+=" --bzip2"
234 postfix="bz2"
235
233 case $KMNAME in 236 case ${KMNAME} in
234 kdebase-apps) 237 kdebase-apps)
235 tarball="${KMNAME#-apps}-${PV}.tar.bz2" 238 # kdebase/apps -> kdebase-apps
239 tarball="kdebase-${PV}.tar.${postfix}"
240 if ! slot_is_at_least 4.6 ${SLOT} || [[ ${PV} == "4.6.0" ]]; then
241 moduleprefix=apps/
242 KMTARPARAMS+=" --transform=s|apps/||"
243 fi
236 ;; 244 ;;
237 *) 245 *)
246 # Create tarball name from module name (this is the default)
238 tarball="${KMNAME}-${PV}.tar.bz2" 247 tarball="${KMNAME}-${PV}.tar.${postfix}"
239 ;; 248 ;;
240 esac 249 esac
250
251 # Full path to source tarball
241 tarfile="${DISTDIR}/${tarball}" 252 tarfile="${DISTDIR}/${tarball}"
253
254 # Detect real toplevel dir from tarball name - it will be used upon extraction
255 # and in __list_needed_subdirectories
256 topdir="${tarball%.tar.*}/"
242 257
243 ebegin "Unpacking parts of ${tarball} to ${WORKDIR}" 258 ebegin "Unpacking parts of ${tarball} to ${WORKDIR}"
244 259
245 kde4-meta_create_extractlists 260 kde4-meta_create_extractlists
246 261
247 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \ 262 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \
248 AUTHORS COPYING INSTALL README NEWS ChangeLog 263 AUTHORS COPYING INSTALL README NEWS ChangeLog
249 do 264 do
250 extractlist="${extractlist} ${KMNAME}-${PV}/${f}" 265 extractlist+=" ${topdir}${moduleprefix}${f}"
251 done 266 done
252 extractlist="${extractlist} $(__list_needed_subdirectories)" 267 extractlist+=" $(__list_needed_subdirectories)"
253 KMTARPARAMS="${KMTARPARAMS} -j"
254 268
255 pushd "${WORKDIR}" > /dev/null 269 pushd "${WORKDIR}" > /dev/null
270
271 # @ECLASS-VARIABLE: KDE4_STRICTER
272 # @DESCRIPTION:
273 # Print out all issues found executing tar / kmextract files
274 # Set on if you want to find issues in kde-base ebuild unpack sequences
256 [[ -n ${KDE4_STRICTER} ]] && echo tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} >&2 275 [[ -n ${KDE4_STRICTER} ]] && echo 'tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist}'
257 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null 276 if [[ ${I_KNOW_WHAT_I_AM_DOING} ]]; then
277 # to make the devs happy - bug 338397
278 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} || ewarn "tar extract command failed at least partially - continuing anyway"
279 else
280 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null || echo "tar extract command failed at least partially - continuing anyway"
281 fi
258 282
259 # Default $S is based on $P; rename the extracted directory to match $S if necessary 283 # Default $S is based on $P; rename the extracted directory to match $S if necessary
260 mv ${KMNAME}-${PV} ${P} || die "Died while moving \"${KMNAME}-${PV}\" to \"${P}\"" 284 mv ${topdir} ${P} || die "Died while moving \"${topdir}\" to \"${P}\""
261 285
262 popd > /dev/null 286 popd > /dev/null
263 287
264 eend $? 288 eend $?
265 289
266 # We need to clear it here to make verification below work 290 # We need to clear it here to make verification below work
267 unset moduleprefix 291 unset moduleprefix
268 292
269 if [[ -n ${KDE4_STRICTER} ]]; then 293 if [[ -n ${KDE4_STRICTER} ]]; then
270 for f in $(__list_needed_subdirectories fatal); do 294 for f in $(__list_needed_subdirectories fatal); do
271 if [[ ! -e "${S}/${f#*/}" ]]; then 295 if [[ ! -e ${S}/${f#*/} ]]; then
272 eerror "'${f#*/}' is missing" 296 eerror "'${f#*/}' is missing"
273 abort=true 297 abort=true
274 fi 298 fi
275 done 299 done
276 [[ -n ${abort} ]] && die "There were missing files." 300 [[ -n ${abort} ]] && die "There were missing files."
277 fi 301 fi
302
303 # We don't need it anymore
304 unset topdir
278 fi 305 fi
279} 306}
280 307
281# @FUNCTION: kde4-meta_create_extractlists 308# @FUNCTION: kde4-meta_create_extractlists
282# @DESCRIPTION: 309# @DESCRIPTION:
284# Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, 311# Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY,
285# KMEXTRACTONLY and KMTARPARAMS. 312# KMEXTRACTONLY and KMTARPARAMS.
286kde4-meta_create_extractlists() { 313kde4-meta_create_extractlists() {
287 debug-print-function ${FUNCNAME} "$@" 314 debug-print-function ${FUNCNAME} "$@"
288 315
289 if has htmlhandbook ${IUSE//+} && use htmlhandbook; then 316 # Add default handbook locations
317 # FIXME - legacy code - remove when 4.4.5 is gone or preferrably port 4.4.5.
318 if ! slot_is_at_least 4.5 ${SLOT} && has handbook ${IUSE//+} && use handbook && [[ -z ${KMNOMODULE} ]]; then
290 # We use the basename of $KMMODULE because $KMMODULE can contain 319 # We use the basename of $KMMODULE because $KMMODULE can contain
291 # the path to the module subdirectory. 320 # the path to the module subdirectory.
321 KMEXTRA_NONFATAL+="
322 doc/${KMMODULE##*/}"
323 fi
324
325 # Add default handbook locations
326 if [[ -z ${KMNOMODULE} ]] && ( [[ ${KDE_HANDBOOK} == always ]] || ( [[ ${KDE_HANDBOOK} == optional ]] && use handbook ) ); then
292 KMEXTRA_NONFATAL="${KMEXTRA_NONFATAL} doc/${KMMODULE##*/}" 327 KMEXTRA_NONFATAL+=" doc/${KMMODULE##*/}"
293 fi 328 fi
294 329
295 # Add some CMake-files to KMEXTRACTONLY. 330 # Add some CMake-files to KMEXTRACTONLY.
296 # Note that this actually doesn't include KMEXTRA handling. 331 # Note that this actually doesn't include KMEXTRA handling.
297 # In those cases you should care to add the relevant files to KMEXTRACTONLY 332 # In those cases you should care to add the relevant files to KMEXTRACTONLY
298 case ${KMNAME} in 333 case ${KMNAME} in
299 kdebase) 334 kdebase)
300 KMEXTRACTONLY="${KMEXTRACTONLY} 335 if ! slot_is_at_least 4.6 ${SLOT} || [[ ${PV} == "4.6.0" ]]; then
336 KMEXTRACTONLY+="
301 apps/config-apps.h.cmake 337 apps/config-apps.h.cmake
302 apps/ConfigureChecks.cmake" 338 apps/ConfigureChecks.cmake"
339 else
340 KMEXTRACTONLY+="
341 config-apps.h.cmake
342 ConfigureChecks.cmake"
343 fi
303 ;; 344 ;;
304 kdebase-apps) 345 kdebase-apps)
305 KMEXTRACTONLY="${KMEXTRACTONLY} 346 KMEXTRACTONLY+="
306 config-apps.h.cmake 347 config-apps.h.cmake
307 ConfigureChecks.cmake" 348 ConfigureChecks.cmake"
308 ;; 349 ;;
309 kdebase-runtime) 350 kdebase-runtime)
310 KMEXTRACTONLY="${KMEXTRACTONLY} 351 KMEXTRACTONLY+="
311 config-runtime.h.cmake" 352 config-runtime.h.cmake"
312 ;; 353 ;;
313 kdebase-workspace) 354 kdebase-workspace)
314 KMEXTRACTONLY="${KMEXTRACTONLY} 355 KMEXTRACTONLY+="
315 config-unix.h.cmake 356 config-unix.h.cmake
316 ConfigureChecks.cmake 357 ConfigureChecks.cmake
317 config-workspace.h.cmake 358 config-workspace.h.cmake
318 config-X11.h.cmake 359 config-X11.h.cmake
319 startkde.cmake 360 startkde.cmake
320 KDE4WorkspaceConfig.cmake.in" 361 KDE4WorkspaceConfig.cmake.in"
321 ;; 362 ;;
322 kdegames) 363 kdegames)
323 if [[ ${PN} != libkdegames ]]; then 364 if [[ ${PN} != libkdegames ]]; then
324 KMEXTRACTONLY="${KMEXTRACTONLY} 365 KMEXTRACTONLY+="
325 libkdegames" 366 libkdegames/"
367 KMLOADLIBS="${KMLOADLIBS} libkdegames"
326 fi 368 fi
327 ;; 369 ;;
328 kdepim) 370 kdepim)
329 KMEXTRACTONLY="${KMEXTRACTONLY} 371 if [[ ${PN} != libkdepim ]]; then
372 KMEXTRACTONLY+="
373 libkdepim/"
374 fi
375 KMEXTRACTONLY+="
376 config-enterprise.h.cmake
330 kleopatra/ConfigureChecks.cmake 377 kleopatra/ConfigureChecks.cmake"
331 libkdepim/kdepim_export.h" 378 if slot_is_at_least 4.5 ${SLOT}; then
379 KMEXTRACTONLY+="
380 CTestCustom.cmake
381 kdepim-version.h.cmake"
382 else
383 KMEXTRACTONLY+="
384 kdepim-version.h"
385 fi
332 if has kontact ${IUSE//+} && use kontact; then 386 if has kontact ${IUSE//+} && use kontact; then
387 KMEXTRA+="
333 KMEXTRA="${KMEXTRA} kontact/plugins/${PLUGINNAME:-${PN}}" 388 kontact/plugins/${PLUGINNAME:-${PN}}/"
334 KMEXTRACTONLY="${KMEXTRACTONLY} kontactinterfaces/"
335 fi 389 fi
390 ;;
391 kdeutils)
392 KMEXTRACTONLY+="
393 kdeutils-version.h"
336 ;; 394 ;;
337 koffice) 395 koffice)
338 KMEXTRACTONLY="${KMEXTRACTONLY} 396 KMEXTRACTONLY+="
339 config-endian.h.cmake
340 filters/config-filters.h.cmake 397 filters/config-filters.h.cmake
398 "
399 case ${PV} in
400 2.[12].*)
401 KMEXTRACTONLY+="
341 config-openctl.h.cmake 402 config-endian.h.cmake
342 config-openexr.h.cmake 403 config-openexr.h.cmake
343 config-opengl.h.cmake 404 config-opengl.h.cmake
344 config-prefix.h.cmake" 405 config-prefix.h.cmake"
406 ;;
407 esac
345 ;; 408 ;;
346 esac 409 esac
347 # Don't install cmake modules for split ebuilds, to avoid collisions. 410 # Don't install cmake modules for split ebuilds, to avoid collisions.
411 # note: kdegraphics >= 4.6.2 does not even have code to do that, so we
412 # should not try in that case
413 if [[ ${KMNAME} != kdegraphics ]] || { [[ ${SLOT} != 4.6 || ${PV} < 4.6.2 ]] && ! slot_is_at_least 4.7 ${SLOT}; }; then
348 case ${KMNAME} in 414 case ${KMNAME} in
349 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics|kdepim) 415 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics)
350 case ${PN} in 416 case ${PN} in
351 libkdegames|libkdeedu|marble|libkworkspace) 417 libkdegames|libkdeedu|libkworkspace)
352 KMEXTRA="${KMEXTRA} 418 KMEXTRA+="
353 cmake/modules/" 419 cmake/modules/"
354 ;; 420 ;;
355 *) 421 *)
356 KMCOMPILEONLY="${KMCOMPILEONLY} 422 KMCOMPILEONLY+="
357 cmake/modules/" 423 cmake/modules/"
358 ;; 424 ;;
359 esac 425 esac
360 ;; 426 ;;
361 esac 427 esac
428 fi
362 429
363 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME}: KMEXTRACTONLY ${KMEXTRACTONLY}" 430 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME}: KMEXTRACTONLY ${KMEXTRACTONLY}"
364} 431}
365 432
366__list_needed_subdirectories() { 433__list_needed_subdirectories() {
367 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist topdir 434 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist
368 435
369 # We expand KMEXTRA by adding CMakeLists.txt files 436 # We expand KMEXTRA by adding CMakeLists.txt files
370 kmextra="${KMEXTRA}" 437 kmextra="${KMEXTRA}"
371 [[ ${1} != fatal ]] && kmextra="${kmextra} ${KMEXTRA_NONFATAL}" 438 [[ ${1} != fatal ]] && kmextra+=" ${KMEXTRA_NONFATAL}"
372 for i in ${kmextra}; do 439 for i in ${kmextra}; do
373 kmextra_expanded="${kmextra_expanded} ${i}" 440 kmextra_expanded+=" ${i}"
374 j=$(dirname ${i}) 441 j=$(dirname ${i})
375 while [[ ${j} != "." ]]; do 442 while [[ ${j} != "." ]]; do
376 kmextra_expanded="${kmextra_expanded} ${j}/CMakeLists.txt"; 443 kmextra_expanded+=" ${j}/CMakeLists.txt";
377 j=$(dirname ${j}) 444 j=$(dirname ${j})
378 done 445 done
379 done 446 done
380 447
381 # Expand KMMODULE 448 # Expand KMMODULE
382 if [[ -n ${KMMODULE} ]]; then 449 if [[ -n ${KMMODULE} ]]; then
383 kmmodule_expanded="${KMMODULE}" 450 kmmodule_expanded="${KMMODULE}"
384 j=$(dirname ${KMMODULE}) 451 j=$(dirname ${KMMODULE})
385 while [[ ${j} != "." ]]; do 452 while [[ ${j} != "." ]]; do
386 kmmodule_expanded="${kmmodule_expanded} ${j}/CMakeLists.txt"; 453 kmmodule_expanded+=" ${j}/CMakeLists.txt";
387 j=$(dirname ${j}) 454 j=$(dirname ${j})
388 done 455 done
389 fi 456 fi
390 457
391 # Expand KMCOMPILEONLY 458 # Expand KMCOMPILEONLY
392 for i in ${KMCOMPILEONLY}; do 459 for i in ${KMCOMPILEONLY}; do
393 kmcompileonly_expanded="${kmcompileonly_expanded} ${i}" 460 kmcompileonly_expanded+=" ${i}"
394 j=$(dirname ${i}) 461 j=$(dirname ${i})
395 while [[ ${j} != "." ]]; do 462 while [[ ${j} != "." ]]; do
396 kmcompileonly_expanded="${kmcompileonly_expanded} ${j}/CMakeLists.txt"; 463 kmcompileonly_expanded+=" ${j}/CMakeLists.txt";
397 j=$(dirname ${j}) 464 j=$(dirname ${j})
398 done 465 done
399 done 466 done
400 467
401 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}" 468 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}"
402 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmmodule_expanded: ${kmmodule_expanded}" 469 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmmodule_expanded: ${kmmodule_expanded}"
403 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmcompileonly_expanded: ${kmcompileonly_expanded}" 470 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmcompileonly_expanded: ${kmcompileonly_expanded}"
404 471
405 case ${PV} in
406 scm|9999*) : ;;
407 *) topdir="${KMNAME}-${PV}/" ;;
408 esac
409 # Create final list of stuff to extract 472 # Create final list of stuff to extract
410 # We append topleveldir only when specified (usually for tarballs) 473 # We append topdir only when specified (usually for tarballs)
411 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \ 474 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \
412 ${KMEXTRACTONLY} 475 ${KMEXTRACTONLY}
413 do 476 do
414 extractlist="${extractlist} ${topdir}${moduleprefix}${i}" 477 extractlist+=" ${topdir}${moduleprefix}${i}"
415 done 478 done
416 479
417 echo ${extractlist} 480 echo ${extractlist}
418} 481}
419 482
425 488
426 kde4-meta_change_cmakelists 489 kde4-meta_change_cmakelists
427 kde4-base_src_prepare 490 kde4-base_src_prepare
428} 491}
429 492
430 493# @FUNCTION: _change_cmakelists_parent_dirs
431# FIXME: no comment here? 494# @DESCRIPTION:
495# Adjust CMakeLists.txt to shadow subdirectories
496# that are not required for the build.
432_change_cmakelists_parent_dirs() { 497_change_cmakelists_parent_dirs() {
433 debug-print-function ${FUNCNAME} "$@" 498 debug-print-function ${FUNCNAME} "$@"
434 499
435 local _olddir _dir 500 local _olddir _dir
436 _dir="${S}"/${1} 501 _dir="${S}"/${1}
437 until [[ ${_dir} == "${S}" ]]; do 502 until [[ ${_dir} == ${S} ]]; do
438 _olddir=$(basename "${_dir}") 503 _olddir=$(basename "${_dir}")
439 _dir=$(dirname "${_dir}") 504 _dir=$(dirname "${_dir}")
440 debug-print "${LINENO}: processing ${_dir} CMakeLists.txt searching for ${_olddir}" 505 debug-print "${LINENO}: processing ${_dir} CMakeLists.txt searching for ${_olddir}"
441 if [[ -f ${_dir}/CMakeLists.txt ]]; then 506 if [[ -f ${_dir}/CMakeLists.txt ]]; then
442 sed -e "/add_subdirectory[[:space:]]*([[:space:]]*${_olddir}[[:space:]]*)/s/#DONOTCOMPILE //g" \ 507 sed -e "/add_subdirectory[[:space:]]*([[:space:]]*${_olddir}[[:space:]]*)/s/#DONOTCOMPILE //g" \
444 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}" 509 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}"
445 fi 510 fi
446 done 511 done
447} 512}
448 513
449# FIXME: add description
450# @FUNCTION: kde4-meta_change_cmakelists 514# @FUNCTION: kde4-meta_change_cmakelists
451# @DESCRIPTION: 515# @DESCRIPTION:
516# Adjust CMakeLists.txt to comply to our splitting.
452kde4-meta_change_cmakelists() { 517kde4-meta_change_cmakelists() {
453 debug-print-function ${FUNCNAME} "$@" 518 debug-print-function ${FUNCNAME} "$@"
454 519
455 pushd "${S}" > /dev/null 520 pushd "${S}" > /dev/null
456 521
457 comment_all_add_subdirectory ./ 522 comment_all_add_subdirectory ./
458 523
459 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt 524 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt
460 if [[ -f "${S}"/CMakeLists.txt ]]; then 525 if [[ -f CMakeLists.txt ]]; then
461 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 526 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
462 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 527 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
463 -i "${S}"/CMakeLists.txt || die "${LINENO}: cmake sed died" 528 -i CMakeLists.txt || die "${LINENO}: cmake sed died"
464 fi 529 fi
465 530
466 if [[ -z ${KMNOMODULE} ]]; then 531 if [[ -z ${KMNOMODULE} ]]; then
467 # Restore "add_subdirectory" in $KMMODULE subdirectories 532 # Restore "add_subdirectory" in $KMMODULE subdirectories
468 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 533 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | \
534 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
469 die "${LINENO}: died in KMMODULE section" 535 die "${LINENO}: died in KMMODULE section"
470 _change_cmakelists_parent_dirs ${KMMODULE} 536 _change_cmakelists_parent_dirs ${KMMODULE}
471 fi 537 fi
472 538
539 local i
540
541 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY
542 for i in ${KMEXTRACTONLY}; do
543 if [[ -d ${i} && -f ${i}/../CMakeLists.txt ]]; then
544 sed -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" \
545 -i ${i}/../CMakeLists.txt || \
546 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}"
547 fi
548 done
549
473 # KMCOMPILEONLY 550 # KMCOMPILEONLY
474 local i
475 for i in ${KMCOMPILEONLY}; do 551 for i in ${KMCOMPILEONLY}; do
476 debug-print "${LINENO}: KMCOMPILEONLY, processing ${i}" 552 debug-print "${LINENO}: KMCOMPILEONLY, processing ${i}"
477 # Uncomment "add_subdirectory" instructions inside $KMCOMPILEONLY, then comment "install" instructions. 553 # Uncomment "add_subdirectory" instructions inside $KMCOMPILEONLY, then comment "install" instructions.
478 find "${S}"/${i} -name CMakeLists.txt -print0 | \ 554 find "${S}"/${i} -name CMakeLists.txt -print0 | \
479 xargs -0 sed -i \ 555 xargs -0 sed -i \
496 # KMEXTRA_NONFATAL section 572 # KMEXTRA_NONFATAL section
497 for i in ${KMEXTRA_NONFATAL}; do 573 for i in ${KMEXTRA_NONFATAL}; do
498 if [[ -d "${S}"/${i} ]]; then 574 if [[ -d "${S}"/${i} ]]; then
499 find "${S}"/${i} -name CMakeLists.txt -print0 | \ 575 find "${S}"/${i} -name CMakeLists.txt -print0 | \
500 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 576 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
501 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}" 577 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}"
502 _change_cmakelists_parent_dirs ${i} 578 _change_cmakelists_parent_dirs ${i}
503 fi
504 done
505
506 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY
507 for i in ${KMEXTRACTONLY}; do
508 if [[ -d "${S}"/${i} && -f "${S}"/${i}/../CMakeLists.txt ]]; then
509 sed -i -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" "${S}"/${i}/../CMakeLists.txt || \
510 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}"
511 fi 579 fi
512 done 580 done
513 581
514 case ${KMNAME} in 582 case ${KMNAME} in
515 kdebase-workspace) 583 kdebase-workspace)
516 # COLLISION PROTECT section 584 # COLLISION PROTECT section
517 # Install the startkde script just once, as a part of kde-base/kdebase-startkde, 585 # Install the startkde script just once, as a part of kde-base/kdebase-startkde,
518 # not as a part of every package. 586 # not as a part of every package.
519 if [[ ${PN} != kdebase-startkde && -f "${S}"/CMakeLists.txt ]]; then 587 if [[ ${PN} != kdebase-startkde && -f CMakeLists.txt ]]; then
520 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0. 588 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0.
521 sed -i -e '/startkde/s/^/#DONOTINSTALL /' "${S}"/CMakeLists.txt || \ 589 sed -e '/startkde/s/^/#DONOTINSTALL /' \
522 die "${LINENO}: sed died in the kdebase-startkde collision prevention section" 590 -i CMakeLists.txt || die "${LINENO}: sed died in the kdebase-startkde collision prevention section"
523 fi 591 fi
524 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82 592 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82
525 if [[ ${PN} != libkworkspace ]]; then 593 if [[ ${PN} != libkworkspace ]]; then
526 sed -i -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \ 594 sed -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \
527 CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip EXPORT section" 595 -i CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip config install and fix EXPORT section"
528 fi 596 fi
529 ;; 597 ;;
530 kdebase-runtime) 598 kdebase-runtime)
531 # COLLISION PROTECT section 599 # COLLISION PROTECT section
532 # Only install the kde4 script as part of kde-base/kdebase-data 600 # Only install the kde4 script as part of kde-base/kdebase-data
533 if [[ ${PN} != kdebase-data && -f "${S}"/CMakeLists.txt ]]; then 601 if [[ ${PN} != kdebase-data && -f CMakeLists.txt ]]; then
534 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \ 602 sed -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
535 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed" 603 -i CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
536 fi 604 fi
605 ;;
606 kdenetwork)
607 # Disable hardcoded kdepimlibs check
608 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
609 -i CMakeLists.txt || die "failed to disable hardcoded checks"
537 ;; 610 ;;
538 kdepim) 611 kdepim)
612 # Disable hardcoded checks
613 sed -r -e '/find_package\(KdepimLibs/s/REQUIRED//' \
614 -e '/find_package\((KdepimLibs|Boost|QGpgme|Akonadi|ZLIB|Strigi|SharedDesktopOntologies|Soprano|Nepomuk)/{/macro_optional_/!s/find/macro_optional_&/}' \
615 -e '/macro_log_feature\((Boost|QGPGME|Akonadi|ZLIB|STRIGI|SHAREDDESKTOPONTOLOGIES|Soprano|Nepomuk)_FOUND/s/ TRUE / FALSE /' \
616 -e '/if[[:space:]]*([[:space:]]*BUILD_.*)/s/^/#OVERRIDE /' \
617 -e '/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)/s/^/#OVERRIDE /' \
618 -i CMakeLists.txt || die "failed to disable hardcoded checks"
619 # Disable broken or redundant build logic
620 if ( has kontact ${IUSE//+} && use kontact ) || [[ ${PN} = kontact ]]; then
621 sed -e '/if[[:space:]]*([[:space:]]*BUILD_.*)/s/^/#OVERRIDE /' \
622 -e '/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)/s/^/#OVERRIDE /' \
623 -i kontact/plugins/CMakeLists.txt || die 'failed to override build logic'
624 fi
625 if ! slot_is_at_least 4.5 ${SLOT}; then
539 case ${PN} in 626 case ${PN} in
540 kaddressbook|kalarm|kmailcvt|kontact|korganizer|korn) 627 kalarm|kmailcvt|kontact|korganizer|korn)
541 sed -i -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \ 628 sed -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \
542 -e '/add_custom_target(kmail_xml /,/)/p' "${S}"/kmail/CMakeLists.txt || die "uncommenting xml failed" 629 -e '/add_custom_target(kmail_xml /,/)/p' \
630 -i kmail/CMakeLists.txt || die "uncommenting xml failed"
543 _change_cmakelists_parent_dirs kmail 631 _change_cmakelists_parent_dirs kmail
544 ;; 632 ;;
545 esac 633 esac
634 fi
635 ;;
636 kdewebdev)
637 # Disable hardcoded checks
638 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
639 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2)/' \
640 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt)/' \
641 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost)/' \
642 -i CMakeLists.txt || die "failed to disable hardcoded checks"
546 ;; 643 ;;
547 koffice) 644 koffice)
548 # prevent collisions 645 # Prevent collisions
549 if [[ ${PN} != koffice-data ]]; then 646 if [[ ${PN} != koffice-data ]]; then
550 sed -i -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \ 647 sed -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \
551 "${S}"/cmake/modules/CMakeLists.txt || \ 648 -i cmake/modules/CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
649 sed -e '/install(.\+config-openexr\.h.\+)/d' \
552 die "${LINENO}: sed died in collision prevention section" 650 -i CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
553 sed -i -n -e '1h;1!H;${g;s/install(.\+config-openexr.h.\+)//;p}' \
554 "${S}"/CMakeLists.txt || \
555 die "${LINENO}: sed died in collision prevention section"
556 fi 651 fi
557 esac 652 esac
558 653
559 popd > /dev/null 654 popd > /dev/null
560} 655}
564# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split 659# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split
565# ebuilds. 660# ebuilds.
566kde4-meta_src_configure() { 661kde4-meta_src_configure() {
567 debug-print-function ${FUNCNAME} "$@" 662 debug-print-function ${FUNCNAME} "$@"
568 663
664 # backwards-compatibility: make mycmakeargs an array, if it isn't already
665 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
666 mycmakeargs=(${mycmakeargs})
667 fi
668
669 # Set some cmake default values here (usually workarounds for automagic deps)
670 case ${KMNAME} in
671 kdewebdev)
672 mycmakeargs=(
673 -DWITH_KdepimLibs=OFF
674 -DWITH_LibXml2=OFF
675 -DWITH_LibXslt=OFF
676 -DWITH_Boost=OFF
677 -DWITH_LibTidy=OFF
678 "${mycmakeargs[@]}"
679 )
680 ;;
681 esac
682
569 kde4-base_src_configure 683 kde4-base_src_configure
570} 684}
571 685
572# @FUNCTION: kde4-meta_src_compile 686# @FUNCTION: kde4-meta_src_compile
573# @DESCRIPTION: 687# @DESCRIPTION:
574# General function for compiling split KDE4 applications. 688# General function for compiling split KDE4 applications.
575# Overrides kde4-base_src_compile. 689# Overrides kde4-base_src_compile.
576kde4-meta_src_compile() { 690kde4-meta_src_compile() {
577 debug-print-function ${FUNCNAME} "$@" 691 debug-print-function ${FUNCNAME} "$@"
578 692
579 kde4-base_src_make 693 kde4-base_src_compile "$@"
580} 694}
581 695
582# @FUNCTION: kde4-meta_src_test 696# @FUNCTION: kde4-meta_src_test
583# @DESCRIPTION: 697# @DESCRIPTION:
584# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 698# Currently just calls its equivalent in kde4-base.eclass(5) if
585# ebuilds. 699# I_KNOW_WHAT_I_AM_DOING is set. Use this in split ebuilds.
586kde4-meta_src_test() { 700kde4-meta_src_test() {
587 debug-print-function $FUNCNAME "$@" 701 debug-print-function $FUNCNAME "$@"
588 702
703 if [[ $I_KNOW_WHAT_I_AM_DOING ]]; then
589 kde4-base_src_test 704 kde4-base_src_test
705 else
706 einfo "Tests disabled"
707 fi
590} 708}
591 709
592# @FUNCTION: kde4-meta_src_install 710# @FUNCTION: kde4-meta_src_install
593# @DESCRIPTION: 711# @DESCRIPTION:
594# Function for installing KDE4 split applications. 712# Function for installing KDE4 split applications.
595kde4-meta_src_install() { 713kde4-meta_src_install() {
596 debug-print-function $FUNCNAME "$@" 714 debug-print-function $FUNCNAME "$@"
597 715
598 kde4-meta_src_make_doc 716 # Search ${S}/${KMMODULE} and install common documentation files found
599 cmake-utils_src_install
600
601 if [[ -n ${KMSAVELIBS} ]]; then
602 install_library_dependencies
603 fi
604}
605
606# @FUNCTION: kde4-meta_src_make_doc
607# @DESCRIPTION:
608# This function searches in ${S}/${KMMODULE},
609# and tries to install "AUTHORS ChangeLog* README* NEWS todo" if these files exist.
610kde4-meta_src_make_doc() {
611 debug-print-function ${FUNCNAME} "$@"
612
613 local doc 717 local doc
614 for doc in AUTHORS ChangeLog* README* NEWS TODO; do 718 for doc in "${S}/${KMMODULE}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
615 [[ -s ${KMMODULE}/${doc} ]] && newdoc "${KMMODULE}/${doc}" "${doc}.${KMMODULE##*/}" 719 [[ -f "${doc}" ]] && [[ -s "${doc}" ]] && dodoc "${doc}"
616 done 720 done
617 721
618 kde4-base_src_make_doc 722 kde4-base_src_install
723}
724
725# @FUNCTION: kde4-meta_pkg_preinst
726# @DESCRIPTION:
727# Invoke its equivalent in kde4-base.eclass.
728kde4-meta_pkg_preinst() {
729 debug-print-function ${FUNCNAME} "$@"
730
731 kde4-base_pkg_preinst
619} 732}
620 733
621# @FUNCTION: kde4-meta_pkg_postinst 734# @FUNCTION: kde4-meta_pkg_postinst
622# @DESCRIPTION: 735# @DESCRIPTION:
623# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 736# Invoke kbuildsycoca4.
624# ebuilds.
625kde4-meta_pkg_postinst() { 737kde4-meta_pkg_postinst() {
626 debug-print-function ${FUNCNAME} "$@" 738 debug-print-function ${FUNCNAME} "$@"
627 739
628 kde4-base_pkg_postinst 740 kde4-base_pkg_postinst
629} 741}

Legend:
Removed from v.1.11  
changed lines
  Added in v.1.51

  ViewVC Help
Powered by ViewVC 1.1.20